using Back.Program.Common.Model;
using Microsoft.AspNetCore.Mvc;
using Back.Program.Services.V1.Interfaces;
using Back.Program.Repositories.V1.Interfaces;
using Microsoft.AspNetCore.Http.HttpResults;

namespace Back.Program.Controllers.V1;
[ApiController]
[Route("/api/v1/in/class")]
[ApiExplorerSettings(GroupName = "수업 관리")]
public class ClassController(
    ILogger<ClassController> logger,
    // SessionManager sessionManager,
    // DedicateWeb dedicateWeb,
    IRepositoryService repositoryService,
    IClassService classService)
    : ControllerBase
{
    // [HttpGet("info")]
    [HttpGet]
    [CustomOperation("수업 정보 조회", "수업 정보 조회", "수업관리")]
    public async Task<IActionResult> GetClassInfo(string cid)
    {
        if (string.IsNullOrEmpty(cid)) return BadRequest(APIResponse.InvalidInputError());
        if (!ModelState.IsValid) return BadRequest(APIResponse.InvalidInputError());
        string summary = repositoryService.ReadSummary(typeof(ClassController), "GetClassInfo");
        var result = await classService.GetClassInfo(summary, cid);
        
        return Ok(result);
    }
}