using Back.Program.Common.Model;
using Back.Program.Repositories.V1;
using Back.Program.Repositories.V1.Interfaces;
using Back.Program.Services.V1.Interfaces;

namespace Back.Program.Services.V1;

public class ClassService(IClassRepository classRepository): IClassService
{
    public async Task<APIResponseStatus<object>> GetClassInfo(string summary, string cid)
    {
        var data = await classRepository.FindClassInfo(cid);
        return APIResponse.Send<object>("000", "수업 정보 조회 성공", new
            {
                summary = summary,
                data = data
            }
        );

    }
}